#version 430 core

// Inputs
in vec2 texCoord;

// Outputs
out vec4 finalColor;

// Uniforms
uniform sampler2D u_ImageTexture;
uniform float zNear;
uniform float zFar;

float linearizeDepth (float depth) {
	float z = depth * 2.0 - 1.0; // Back to NDC
	return (2.0 * zNear * zFar) / (zFar + zNear - z * (zFar - zNear));
}

void main()
{	


	float z_b = texture(u_ImageTexture, texCoord).r;
	float z_n = 2.0 * z_b - 1.0;
	float z_e = 2.0 * zNear * zFar / (zFar + zNear - z_n * (zFar - zNear));
	

	float linearDepth =  z_e / zFar;
	finalColor = vec4(vec3(1.0 - linearDepth), 1.0);

    //if (linearDepth > 1.0) {
	//	finalColor = vec4(1.0, 0.0, 0.0, 1.0);
	//}
	//else 
	//{
	//	finalColor = vec4(vec3(1.0 - linearDepth), 1.0);
	//}
}
