#version 430 core

// Vertex Attributes
layout (location = 0) in vec3 aPos;
layout (location = 1) in vec3 aNorm;

// Output
out VS_OUT
{
    out vec3 fWorldPos;
    out vec3 fNorm;
} vs_out;

// Uniforms
layout (location = 0) uniform mat4 mvpMat;
layout (location = 1) uniform mat4 modelMat;
layout (location = 2) uniform mat3 normalMat;

// Logic
void main()
{
	gl_Position = mvpMat * vec4(aPos, 1.0);
	vs_out.fWorldPos = vec3(modelMat * vec4(aPos, 1.0));
	vs_out.fNorm = normalMat * aNorm;
}