#version 430 core
// Define geometry inputs/outputs
layout(points) in;
layout (triangle_strip, max_vertices = 4) out;

// Inputs
in float ttl[];

// Outputs
out vec2 texCoords;
out float f_ttl;

// Uniforms
uniform mat4 projectionMatrix;

// Logic
void main()
{
	const vec2 size = vec2(5, 5);
	vec4 pos = gl_in[0].gl_Position; // Position in view-spcae
	vec2 corner;

	// TODO calculate texcoord, TTL

	// Bottom Left Corner
	corner = pos.xy + vec2(-0.5, -0.5) * size;
	gl_Position = projectionMatrix * vec4(corner.xy, pos.zw);
	texCoords = vec2(0.0, 0.0);
	f_ttl = ttl[0];
	EmitVertex();

	// Bottom Right Corner
	corner = pos.xy + vec2(0.5, -0.5) * size;
	gl_Position = projectionMatrix * vec4(corner.xy, pos.zw);
	texCoords = vec2(1.0, 0.0);
	f_ttl = ttl[0];
	EmitVertex();

	// Top Left Corner
	corner = pos.xy + vec2(-0.5, 0.5) * size;
	gl_Position = projectionMatrix * vec4(corner.xy, pos.zw);
	texCoords = vec2(0.0, 1.0);
	f_ttl = ttl[0];
	EmitVertex();

	// Top Right Corner
	corner = pos.xy + vec2(0.5, 0.5) * size;
	gl_Position = projectionMatrix * vec4(corner.xy, pos.zw);
	texCoords = vec2(1.0, 1.0);
	f_ttl = ttl[0];
	EmitVertex();

	EndPrimitive();
}