#version 430 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) uniform vec3 color;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;

out VertexData {
	vec3 position;
	vec3 normal;
	vec3 color;
} vert;

void main() {
    vec3 world_position=vec3(modelMatrix*vec4(position,1));
	gl_Position = viewProjMatrix * vec4(world_position, 1);
	vert.normal=normal;
	vert.position=world_position;
	vert.color=color;
}