#version 430 core

// Input
in VertexData {
	vec3 position;
	vec3 normal;
} vert;

// in vec3 fNorm;

// Output
out vec4 colorOut;

// Uniforms
layout(location=1) uniform vec3 camPos;

// Constants
vec3 dirLight = vec3(0, 0, -1);

struct DirLight {
	vec3 color;
	vec3 dir;
};

void main()
{
	vec3 color = vec3(1.0, 0.0, 0.0);
	float ka=0.1;
	float kd=0.9;
	float ks=0.3;
	float alpha=10;
	//float brightness = max(0.1, dot(normalize(fNorm), -lightDir));
	//color = color * brightness;

	vec3 normal=normalize(vert.normal);
	vec3 world_position=vert.position;
	vec3 ambient=ka*vec3(1,1,1);

	vec3 specular=vec3(0.0f);
	vec3 diffuse=vec3(0.0f);
	vec3 toEye=normalize(world_position-camPos);

	DirLight dirLight=DirLight(vec3(1.0,1.0,1.0),vec3(0.3,-1.0,0.3));

	diffuse+=kd*max(0,dot(-normalize(dirLight.dir), normal))*dirLight.color;
	vec3 ref=2*dot(normalize(dirLight.dir),normal)*normal-normalize(dirLight.dir);
	specular+=ks*pow(max(dot(ref,toEye),0),alpha)*dirLight.color;

	colorOut = vec4((ambient+diffuse)*color+specular, 1);
}