#version 440 core

// Input
layout (location = 0) in vec3 aPos;
layout (location = 1) in vec3 aNorm;

// Output
out VertexData {
	vec3 position;
	vec3 normal;
} vert;

// Uniforms
layout (location = 0) uniform mat4 modelViewProjectionMat;
layout (location = 2) uniform mat3 normalMat;

void main()
{
    vec4 world_position = modelViewProjectionMat * vec4(aPos, 1.0);
	gl_Position = world_position;
	vert.normal = normalMat * aNorm;
	vert.position = vec3(world_position);
}